﻿Public Class Form1

    Private Sub btnForNextLoop_Click(ByVal sender As System.Object, _
        ByVal e As System.EventArgs) Handles btnForNextLoop.Click

        ' Deklaracja zmiennej.
        Dim intCount As Integer

        ' Usuwanie zawartości listy.
        ClearList()

        ' Wykonywanie kodu pętli.
        For intCount = 1 To 5
            ' Dodawanie elementów do listy.
            lstData.Items.Add("To element " & intCount.ToString & _
                " listy.")
        Next
    End Sub

    Private Sub ClearList()
        ' Usuwanie zawartości listy.
        lstData.Items.Clear()
    End Sub

    Private Sub btnForNextLoopWithStep_Click(ByVal sender As System.Object, _
        ByVal e As System.EventArgs) Handles btnForNextLoopWithStep.Click

        ' Usuwanie zawartości listy.
        ClearList()

        ' Wykonywanie pętli.
        For intCount As Integer = 4 To 62 Step 7
            ' Dodawanie elementów do listy.
            lstData.Items.Add(intCount.ToString)
        Next
    End Sub

    Private Sub btnBackwardsForNextLoop_Click(ByVal sender As System.Object, _
        ByVal e As System.EventArgs) Handles btnBackwardsForNextLoop.Click

        ' Usuwanie zawartości listy.
        ClearList()

        ' Wykonywanie pętli.
        For intCount As Integer = 10 To 1 Step -1
            ' Dodawanie elementów do listy.
            lstData.Items.Add(intCount.ToString)
        Next
    End Sub

    Private Sub btnForEachLoop_Click(ByVal sender As System.Object, _
        ByVal e As System.EventArgs) Handles btnForEachLoop.Click

        ' Usuwanie zawartości listy.
        ClearList()

        ' Wyświetla wszystkie katalogi z katalogu głównego dysku C.
        For Each strFolder As String In _
           My.Computer.FileSystem.GetDirectories("C:\")

            ' Dodawanie elementu do listy.
            lstData.Items.Add(strFolder)
        Next
    End Sub

    Private Sub btnDoUntilLoop_Click(ByVal sender As System.Object, _
        ByVal e As System.EventArgs) Handles btnDoUntilLoop.Click

        ' Deklaracja zmiennych.
        Dim objRandom As New Random
        Dim intRandomNumber As Integer = 0

        ' Czyszczenie listy.
        ClearList()

        ' Przetwarzanie pętli, dopóki intRandomNumber nie równa się 10.
        Do Until intRandomNumber = 10
            ' Pobieranie losowej liczby z przedziału od 0 do 24.
            intRandomNumber = objRandom.Next(25)
            ' Dodawanie tej liczby do listy.
            lstData.Items.Add(intRandomNumber.ToString)
        Loop
    End Sub

    Private Sub btnDoWhileLoop_Click(ByVal sender As System.Object, _
        ByVal e As System.EventArgs) Handles btnDoWhileLoop.Click

        ' Deklaracja zmiennych.
        Dim objRandom As New Random
        Dim intRandomNumber As Integer = 0

        ' Usuwanie zawartości listy.
        ClearList()

        ' Przetwarzanie pętli, dopóki intRandomNumber < 15.
        Do While intRandomNumber < 15
            ' Pobieranie liczby losowej z przedziału od 0 do 24.
            intRandomNumber = objRandom.Next(25)
            ' Dodawanie liczby do listy.
            lstData.Items.Add(intRandomNumber.ToString)
        Loop
    End Sub

    Private Sub btnNestedLoops_Click(ByVal sender As System.Object, _
        ByVal e As System.EventArgs) Handles btnNestedLoops.Click

        ' Usuwanie zawartości listy.
        ClearList()

        ' Przetwarzanie zewnętrznej pętli.
        For intOuterLoop As Integer = 1 To 2
            ' Przetwarzanie zagnieżdżonej (wewnętrznej) pętli.
            For intInnerLoop As Integer = 1 To 3
                lstData.Items.Add(intOuterLoop.ToString & _
                    ", " & intInnerLoop.ToString)
            Next
        Next
    End Sub

    Private Sub btnQuittingAForLoop_Click(ByVal sender As System.Object, _
        ByVal e As System.EventArgs) Handles btnQuittingAForLoop.Click

        ' Usuwanie zawartości listy.
        ClearList()

        ' Wyświetlanie wszystkich katalogów głównego katalogu dysku C.
        For Each strFolder As String In _
           My.Computer.FileSystem.GetDirectories("C:\")

            ' Dodawanie elementu do listy.
            lstData.Items.Add(strFolder)

            ' Czy program doszedł do katalogu C:\Program Files?
            If String.Compare(strFolder, "c:\program files", True) = 0 Then

                ' Informacja dla użytkownika.
                MessageBox.Show("Program znalazł katalog i wychodzi z pętli.", _
                                "Pętle")

                ' Wczesne wychodzenie z pętli.
                Exit For

            End If
        Next
    End Sub

    Private Sub btnQuittingADoLoop_Click(ByVal sender As System.Object, _
        ByVal e As System.EventArgs) Handles btnQuittingADoLoop.Click

        ' Deklaracja zmiennej.
        Dim intCount As Integer = 0

        ' Usuwanie zawartości listy.
        ClearList()

        ' Przetwarzanie pętli.
        Do While intCount < 10

            ' Dodawanie elementu do listy.
            lstData.Items.Add(intCount.ToString)

            ' Zwiększanie wartości zmiennej intCount o 1.
            intCount += 1

            ' Czy należy już zakończyć pętlę?
            If intCount = 3 Then

                Exit Do
            End If

        Loop
    End Sub

End Class
